<?php

// TODO: file and class name must have the same name as project

class Theme_bocian extends ThemeDefault {

	function head() {
		// echo ''; // TODO: dodać bootsrap-theme-bocian
		echo '<meta name="robots" content="noindex, nofollow">';
		UI::inlineCSS(dirname(__FILE__) . '/assets/css/styles.css');
		// main color: #d7142d - red
		echo UI::h('style', [ 'type' => "text/css" ], "
			.AjaxTable { font-size:14px }
			.AjaxTable .tblAjax__head__filter .stickyCol1 button { padding:1px 3px }
			.AjaxTable tbody .stickyCol1 { font-size:12px }
			.popover-content li { text-align:left; font-size:14px }

			.bi-btn-primary { padding:6px 12px; font-size:14px; background-color:#fff; color:#d7142d; border-color:#d7142d; }
			.bi-btn-primary:hover { background-color:#d7142d; color:#fff; border-color:#d7142d; }
			.bi-btn-primary .badge { background-color:#d7142d; color:#fff; border-color:#d7142d; }
			.bi-btn-primary:hover .badge { background-color:#fff; color:#d7142d; border-color:#d7142d; }
			.bi-btn-disabled-group-label { cursor: default; padding:6px 12px; font-size:14px; background-color:#fff; color:#d7142d; border-color:#d7142d; }

			.btn-primary .badge { background-color:#d7142d; color:#fff; }
			.btn-primary:hover .badge { background-color:#fff; color:#d7142d; }

			.btn-xs { padding:6px 12px; }
			.btn-xs .badge { padding:2px 5px; }
		");
		UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/d3.v3.min.js');
		UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/csaladenes/sankey/sankey.js');
		// UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/csaladenes/sankey/sankey-init.js');
		UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/sankey-init-widget.js');
	}


	function top() {
		include dirname(__FILE__) . '/view/top.php';
		//todo: demo load data for graph :DELETE line if tested
		// UI::inlineRawJS(dirname(__FILE__) . '/demoGraph/sampleData/sampleData.js');
		// UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/GetFeature.js');
		// UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/parser.js');
	}

	function footer() {
		include dirname(__FILE__) . '/view/footer.php';
		//todo: ujednolicic wczytanie themy widoków i css w jednym katalogu(obecnie css w katalogu static a widoki w katalogu tmp )
		UI::inlineRawJS(dirname(__FILE__) . '/assets/js/scripts.js');

		if ('ViewTableAjax' === V::get('_route', '', $_GET)
			&& 'default_db/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA' === V::get('namespace', '', $_GET)
		) {
			UI::inlineJS(dirname(__FILE__) . '/assets/js/updateRaportProgress.js', [
				'DBG' => (V::get('DBG', '', $_GET)),
				'DBG_FAKE_ANIM' => (V::get('DBG_FAKE_ANIM', '', $_GET)),
				'URL_FETCH_BI_AUDIT_PROGRESS' => Router::getRoute('UrlAction_Bocian')->getLink('fetchProgressAjax', [ 'SKIP_TIMER' => "1" ])
			]);
		}

		UI::inlineJS(dirname(__FILE__) . '/assets/js/updateLastRaportProgress.js', [
			'DBG' => (V::get('DBG', '', $_GET)),
			'DBG_FAKE_ANIM' => (V::get('DBG_FAKE_ANIM', '', $_GET)),
			'URL_FETCH_BI_AUDIT_PROGRESS' => Router::getRoute('UrlAction_Bocian')->getLink('fetchProgressAjax', [ 'SKIP_TIMER' => "1" ]),
			'URL_BI_AUDIT_RESULT' => Router::getRoute('UrlAction_BiAuditGenerate')->getLink(''),
			'ID_ARG_BI_AUDIT_RESULT' => 'ID_BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA'
		]);


		// override checkbox selecting for live select to localStorage - PROBLEM: how to choose OD/DO?
		if ('ViewTableAjax' === V::get('_route', '', $_GET)
			// TODO: what tables? maybe GET arg?
			// && 'default_db/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA' === V::get('namespace', '', $_GET)
		) {
			$keyPrefix = $this->_getKeyPrefixFromNamespace(V::get('namespace', '', $_GET));
			if ($keyPrefix) {
				UI::inlineJS(dirname(__FILE__) . '/assets/js/createTableSelectedStateObject.js', [
					// 'URI_WPS' => Request::getPathUri() . 'wps.php',
					'KEY_PREFIX' => $keyPrefix,
					'BAZA_OD_DO' => V::get('BAZA_OD_DO', '', $_GET), // OD | DO | ''
					'URL_BAZA_OD' => 'index.php?' . http_build_query(array_merge($_GET, [ 'BAZA_OD_DO' => 'OD' ])),
					'URL_BAZA_DO' => 'index.php?' . http_build_query(array_merge($_GET, [ 'BAZA_OD_DO' => 'DO' ])),
					'URL_BAZA_NONE' => 'index.php?' . http_build_query(array_merge($_GET, [ 'BAZA_OD_DO' => '' ])),
					'DBG' => ('1' === V::get('DBG_JS', '', $_GET)),
				]);
			}
		}
	}
	function _getKeyPrefixFromNamespace($ns) {
		switch ($ns) {
			case 'default_db/BI_audit_KRS/BI_audit_KRS': return 'KRS';
			case 'default_db/BI_audit_KRS_person/BI_audit_KRS_person': return 'KRS/p';
			case 'default_db/BI_audit_MSIG/BI_audit_MSIG': return 'MSIG';
			case 'default_db/BI_audit_MSIG_person/BI_audit_MSIG_person': return 'MSIG/p';
			case 'default_db/BI_audit_CEIDG/BI_audit_CEIDG': return 'CEIDG';
			default: return '';
		}
	}

	function login($data) {
		if (is_array($data) && !empty($data)) {
			extract($data);
		}
		include dirname(__FILE__) . '/view/login.php';
	}

	function logout($data) {
		if (is_array($data) && !empty($data)) {
			extract($data);
		}
		include dirname(__FILE__) . '/view/logout.php';
	}

	function home($data) {
		if (is_array($data) && !empty($data)) {
			extract($data);
		}
		include dirname(__FILE__) . '/view/home.php';
	}

}
